%define libapi		1
%define libmajor	0

Summary:	The Light Display Manager
Name:		lightdm
Version:	1.4.4
Release:	%mkrel 1
License:	GPLv3+
Group:		Graphical desktop/Other
Source0:	https://launchpad.net/lightdm/1.4/%{version}/+download/%{name}-%{version}.tar.gz
Source1:	29lightdm.conf
Source2:	Xsession
#Systemd related:
Source10:	lightdm-tmpfiles.conf
Source11:	lightdm.service
Source12:	lightdm.rules

Patch0:		lightdm-1.2.2-link.patch
Patch1:		lightdm-1.3.1-mga-config.patch
Patch2:		lightdm-1.4.1-pam-modules.patch
# Patches from Fedora:
Patch10:	lightdm-1.3.1-nodaemon_option.patch
Patch11:	lightdm-1.3.1-lock-screen-before-switch.patch
# Patches originally from Fedora:
Patch20:	lightdm-1.4.0-systemd_login1_power.patch

URL:		http://www.freedesktop.org/wiki/Software/LightDM
BuildRequires:	intltool
BuildRequires:	itstool
BuildRequires:	gettext-devel
BuildRequires:	gnome-common
BuildRequires:	gtk-doc
BuildRequires:	pam-devel
BuildRequires:	yelp-tools
BuildRequires:	pkgconfig(gio-2.0)
BuildRequires:	pkgconfig(gio-unix-2.0)
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gobject-2.0)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(libxklavier)
BuildRequires:	pkgconfig(QtCore) < 5.0.0
BuildRequires:	pkgconfig(QtDBus) < 5.0.0
BuildRequires:	pkgconfig(QtGui) < 5.0.0
BuildRequires:	pkgconfig(xdmcp)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	pkgconfig(x11)
Requires:	lightdm-greeter
Requires:	accountsservice

%description
An X display manager that:
  * Has a lightweight codebase
  * Is standards compliant (PAM, etc)
  * Has a well defined interface between the server and user interface
  * Fully themeable (easiest with the webkit interface)
  * Cross-desktop (greeters can be written in any toolkit)

#-------------------------------------------------------------------------

%define liblightdmgobject %mklibname lightdm-gobject %{libapi} %{libmajor}

%package -n %{liblightdmgobject}
Summary:	LightDM GObject client library
Group:		Graphical desktop/Other

%description -n %{liblightdmgobject}
A GObject based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmgobject}
%{_libdir}/liblightdm-gobject-%{libapi}.so.%{libmajor}
%{_libdir}/liblightdm-gobject-%{libapi}.so.%{libmajor}.*

#-------------------------------------------------------------------------

%define liblightdmgir %mklibname lightdm-gir %{libapi}

%package -n %{liblightdmgir}
Summary:	Typelib file for liblightdm-1
Group:		Graphical desktop/Other
Requires:	%{liblightdmgobject} = %{version}-%{release}

%description -n %{liblightdmgir}
A GObject based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmgir}
%{_libdir}/girepository-1.0/LightDM-%{libapi}.typelib

#-------------------------------------------------------------------------

%define liblightdmgobjectdevel %mklibname -d lightdm-gobject

%package -n %{liblightdmgobjectdevel}
Summary:	LightDM client library (development files)
Group:		Graphical desktop/Other
Requires:	%{liblightdmgobject} = %{version}-%{release}
Provides:	lightdm-gobject-devel = %{version}-%{release}

%description -n %{liblightdmgobjectdevel}
A GObject based library for LightDM clients to use to interface with LightDM.

This package contains header files and development information, which
is useful for building LightDM greeters and user switchers.

%files -n %{liblightdmgobjectdevel}
%doc %{_datadir}/gtk-doc/html/lightdm-gobject-%{libapi}
%{_includedir}/lightdm-gobject-%{libapi}/
%{_libdir}/liblightdm-gobject-%{libapi}.so
%{_libdir}/pkgconfig/liblightdm-gobject-%{libapi}.pc
%{_datadir}/gir-1.0/LightDM-%{libapi}.gir
%{_datadir}/vala/vapi/liblightdm-gobject-%{libapi}.vapi

#-------------------------------------------------------------------------

%define libqtapi 2
%define liblightdmqt %mklibname lightdm-qt %{libqtapi} %{libmajor}

%package -n %{liblightdmqt}
Summary:	LightDM Qt client library
Group:		Graphical desktop/Other

%description -n %{liblightdmqt}
A Qt based library for LightDM clients to use to interface with LightDM.

%files -n %{liblightdmqt}
%{_libdir}/liblightdm-qt-%{libqtapi}.so.%{libmajor}
%{_libdir}/liblightdm-qt-%{libqtapi}.so.%{libmajor}.*

#-------------------------------------------------------------------------

%define liblightdmqtdevel %mklibname -d lightdm-qt

%package -n %{liblightdmqtdevel}
Summary:	LightDM client library (development files)
Group:		Graphical desktop/Other
Requires:	%{liblightdmqt} = %{version}-%{release}
Provides:	lightdm-qt-devel = %{version}-%{release}

%description -n %{liblightdmqtdevel}
A Qt based library for LightDM clients to use to interface with LightDM.

This package contains header files and development information, which
is useful for building LightDM greeters and user switchers.

%files -n %{liblightdmqtdevel}
%{_includedir}/lightdm-qt-%{libqtapi}
%{_libdir}/liblightdm-qt-%{libqtapi}.so
%{_libdir}/pkgconfig/liblightdm-qt-%{libqtapi}.pc

#-------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p0 -b .linking
%patch1 -p1 -b .mga
%patch2 -p1 -b .pamfix
%patch10 -p1 -b .nodaemon
#patch11 -p1 -b .lock
%patch20 -p1 -b .login1
mkdir -p m4

%build
autoreconf -vfi
export PATH=$PATH:%{_qt4_bindir}
%configure2_5x \
	--disable-static \
	--disable-tests \
	--enable-introspection \
	--with-greeter-session=lightdm-greeter
%make

%install
%makeinstall_std

# dm config
install -Dpm644 %{SOURCE1} %{buildroot}/%{_datadir}/X11/dm.d/29lightdm.conf

# session wrapper script to source /etc/profile and ~/.profile if they exists
install -Dpm755 %{SOURCE2} %{buildroot}/%{_sysconfdir}/%{name}/Xsession

# will be created when lightdm starts
install -d %{buildroot}%{_localstatedir}/log/%{name}
touch %{buildroot}%{_localstatedir}/log/%{name}/%{name}.log

# directory for remote sessions
mkdir -p %{buildroot}%{_datadir}/%{name}/remote-sessions

# for systemd
install -Dpm 644 %{SOURCE10} %{buildroot}%{_prefix}/lib/tmpfiles.d/lightdm.conf
install -Dpm 644 %{SOURCE11} %{buildroot}%{_unitdir}/lightdm.service
install -Dpm 644 %{SOURCE12} %{buildroot}%{_datadir}/polkit-1/rules.d/lightdm.rules

#we don't want these
find %{buildroot} -name "*.la" -delete
rm -f %{buildroot}%{_sysconfdir}/apparmor.d/lightdm-guest-session

%find_lang %{name}

%pre
%_pre_useradd %{name} %{_localstatedir}/log/%{name} /sbin/nologin

%if 0
%preun
%_preun_service %{name}
%endif

%post
%create_ghostfile %{_localstatedir}/log/%{name}/%{name}.log %{name} %{name} 0644

%if 0
%_post_service %{name}
%endif

%files -f %name.lang
%dir %{_sysconfdir}/%{name}
%{_sysconfdir}/%{name}/Xsession
%config(noreplace) %{_sysconfdir}/%{name}/keys.conf
%config(noreplace) %{_sysconfdir}/%{name}/lightdm.conf
%config(noreplace) %{_sysconfdir}/%{name}/users.conf
%attr(-,lightdm,lightdm) %{_localstatedir}/log/%{name}/
%ghost %{_localstatedir}/log/%{name}/%{name}.log
%{_sysconfdir}/dbus-1/system.d/org.freedesktop.DisplayManager.conf
%{_sysconfdir}/init/lightdm.conf
%{_sysconfdir}/pam.d/lightdm*
%{_datadir}/X11/dm.d/29lightdm.conf
%{_datadir}/polkit-1/rules.d/lightdm.rules
%{_datadir}/%{name}/
%{_sbindir}/%{name}
%{_bindir}/dm-tool
%{_libexecdir}/%{name}/*
%{_mandir}/man1/%{name}.1*
%{_datadir}/help/C/%{name}/
%{_prefix}/lib/tmpfiles.d/lightdm.conf
%{_unitdir}/lightdm.service


%changelog
* Mon Oct 07 2013 wally <wally> 1.4.4-1.mga3
+ Revision: 492526
- new stable update 1.4.4 to fix handling of corrupt X
  authority files

* Thu Sep 12 2013 wally <wally> 1.4.3-1.mga3
+ Revision: 478113
- new bugfix release 1.4.3
- fix incorrect .Xauthority permissions (CVE-2013-4331) (mga#11219)
- fix device file permission issues when using su (mga#11071)
- revert 'allow logins with empty passwd' as the change was never actually pushed to updates

* Wed Jun 05 2013 wally <wally> 1.4.1-2.1.mga3
+ Revision: 437674
- allow logins with empty passwd (mga#10416)

* Tue Apr 09 2013 wally <wally> 1.4.1-2.mga3
+ Revision: 409179
- set session class to greeter for lightdm-greeter

* Wed Mar 27 2013 wally <wally> 1.4.1-1.mga3
+ Revision: 405742
- new version 1.4.1

* Sat Jan 12 2013 fwang <fwang> 1.4.0-8.mga3
+ Revision: 358919
- mkdir m4

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sat Dec 22 2012 wally <wally> 1.4.0-7.mga3
+ Revision: 333825
- upload to release
  * enables reboot and shutdown from greeter menu after consolekit removal (mga#7995)
  * port to systemd-logind (mga#7995)

* Sat Dec 22 2012 wally <wally> 1.4.0-6.2.mga3
+ Revision: 333812
- fix systemd-logind patch (thx Derek Jennings)

* Mon Dec 17 2012 wally <wally> 1.4.0-6.1.mga3
+ Revision: 332179
- add systemd-logind patch from Fedora
- upload to testing

* Mon Oct 22 2012 wally <wally> 1.4.0-6.mga3
+ Revision: 309222
- disable post/preun service scripts for now

* Fri Oct 19 2012 ovitters <ovitters> 1.4.0-5.mga3
+ Revision: 308325
- don't mention consolekit in description

* Fri Oct 19 2012 wally <wally> 1.4.0-4.mga3
+ Revision: 308321
- add systemd support (originally from Fedora)
- fix dm config (add FNDSESSION_EXEC)

* Mon Oct 15 2012 wally <wally> 1.4.0-3.mga3
+ Revision: 306735
- properly own previously added remote sessions directory

* Mon Oct 15 2012 wally <wally> 1.4.0-2.mga3
+ Revision: 306722
- create a directory for possible remote session files

* Fri Oct 05 2012 wally <wally> 1.4.0-1.mga3
+ Revision: 302863
- new version 1.4.0

* Thu Aug 30 2012 wally <wally> 1.3.3-1.mga3
+ Revision: 285852
- new version 1.3.3
- disable lock-screen-before-switch.patch
- tighten qt build deps

* Sat Jul 28 2012 wally <wally> 1.3.2-6.mga3
+ Revision: 275420
- allow to select used greeter with alternatives system

* Tue Jul 17 2012 wally <wally> 1.3.2-5.mga3
+ Revision: 271985
- rediff pam modules patch to enable tmpfs support for xguest account (mga#4950)

* Sat Jul 14 2012 wally <wally> 1.3.2-4.mga3
+ Revision: 270745
- rediff pam modules patch to fix autologin issues

* Sat Jul 14 2012 wally <wally> 1.3.2-3.mga3
+ Revision: 270740
- rediff pam modules patch to allow reboot etc from greeter menu

* Sat Jul 14 2012 wally <wally> 1.3.2-2.mga3
+ Revision: 270731
- rediff pam modules patch to add optional gnome keyring support (unlocks the 'login' keyring at login)

* Sat Jul 14 2012 wally <wally> 1.3.2-1.mga3
+ Revision: 270701
- new version 1.3.2

* Tue Jun 26 2012 wally <wally> 1.3.1-6.mga3
+ Revision: 264060
- fix P2 after previous change

* Tue Jun 26 2012 wally <wally> 1.3.1-5.mga3
+ Revision: 264017
- fix net_applet yelling about wrong password (redo P2)
- rename P2

* Tue Jun 26 2012 wally <wally> 1.3.1-4.mga3
+ Revision: 263830
- add session wrapper script to source /etc/profile and/or ~/.profile when starting session if they exists (fixes PATH issue)

* Mon Jun 25 2012 wally <wally> 1.3.1-3.mga3
+ Revision: 263709
- add patch to fix ACLs (fixes no sound problem)
- clean .spec a bit

* Sun Jun 24 2012 wally <wally> 1.3.1-2.mga3
+ Revision: 263185
- add lock screen before switch patch from Fedora
- add ghost file for log
- tag some docs as such

* Sat Jun 23 2012 wally <wally> 1.3.1-1.mga3
+ Revision: 262834
- new version 1.3.1
- add nodaemon patch from Fedora
- add patch to modify default settings suitable for Mageia
- add support for drakedm
- require accountsservice
- clean .spec a bit

* Sat Jun 09 2012 fwang <fwang> 1.2.2-1.mga3
+ Revision: 258393
- new version 1.2.2

* Sat Apr 07 2012 fwang <fwang> 1.0.11-1.mga2
+ Revision: 229459
- new version 1.0.11
- fix linkage

* Mon Jan 02 2012 fwang <fwang> 1.0.6-1.mga2
+ Revision: 189591
- workaround for scripts
- fix build with latest glib
- fix build
- use gnome-autogen
- br gettext
- linkage fix
- new version 1.0.6

* Sun Oct 02 2011 fwang <fwang> 1.0.0-1.mga2
+ Revision: 150819
- new version 1.0.0

* Sat Sep 17 2011 fwang <fwang> 0.9.7-1.mga2
+ Revision: 144567
- update file list
- br dbus-glib for dbus-binding-tool
- new version 0.9.7
- imported package lightdm

